﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.8
@EndOfDesignText@
Sub Process_Globals
	Private fx As JFX
	Private xui As XUI
	Private lblcolor As Label
	Private lblcolorname As Label
	Public jlst As List
	Private lblchild As Label
	Private lblidname As Label
	Private lblgrchild As Label
	Dim childrenlist As Map
End Sub

Public Sub fill_clvnamedcolors
	Dim jstr As String = File.ReadString(File.DirAssets,"colornames.json")
	jlst = jstr.As(JSON).ToList
	Main.clvnamedcolors.Clear
	For i = 1 To jlst.Size -1
		Dim rec As List = jlst.Get(i)
		Dim pn As Pane = set_clvnamedcolor_item(rec,i)
		Main.clvnamedcolors.Add(pn,rec.Get(2))
	Next
End Sub
Private Sub set_clvnamedcolor_item(rec As List,index As Int) As Pane
	Dim pn As Pane
	pn.Initialize("")
	pn.LoadLayout("clvnamedcolorsitem_layout")
	pn.SetLayoutAnimated(0, 0, 0, 240, 45)
	Dim clrstr As String = rec.Get(3)
	Dim R As Int = clrstr.SubString2(0,clrstr.IndexOf(","))
	Dim G As Int = clrstr.SubString2(clrstr.IndexOf(",")+1,clrstr.LastIndexOf(","))
	Dim B As Int = clrstr.SubString(clrstr.LastIndexOf(",")+1)
	lblcolor.TextColor = ContrastColor(xui.Color_ARGB(255,R,G,B))
	lblcolor.Text = " " & index
	lblcolor.Style = "-fx-background-color:" & rec.Get(2)
	lblcolorname.Text = " " & rec.Get(1)
	Return pn
End Sub
Public Sub get_namedcolor_index(grad As String) As Int
	Dim idx As Int
	For i = 1 To jlst.Size -1
		Dim rec As List = jlst.Get(i)
		idx = rec.IndexOf(grad)
		If idx <> -1 Then Return i
	Next
	Return -1
End Sub
Public Sub ContrastColor(Color As Int) As Paint
	'From https://stackoverflow.com/a/41335343
	'Counting the perceptive luminance - human eye favors green color...
	'                                        Red                                           Green                                       Blue
	Dim lum As Double = 1 - (0.299 * Bit.And(Bit.ShiftRight(Color,16),0xFF) + 0.587 * Bit.And(Bit.ShiftRight(Color,8),0XFF) + 0.114 * Bit.And(Color,0xFF)) / 255
	If lum < 0.5 Then
		Return fx.Colors.Black
	Else
		Return fx.Colors.White
	End If
End Sub

Public Sub fill_cmbfont
	Dim fntlst As List = fx.GetAllFontFamilies
	For i = 0 To fntlst.Size -1
		Dim fntname As String = fntlst.Get(i)
		Main.cmbfont.Items.Add(fntname)
	Next
End Sub
Public Sub fill_cmbalign
	Dim alignlst As List = Array As String("TOP_LEFT","TOP_CENTER","TOP_RIGHT", _
										   "CENTER_LEFT","CENTER","CENTER_RIGHT", _
										   "BOTTOM_LEFT","BOTTOM_CENTER","BOTTOM_RIGHT", _
										   "BASELINE_LEFT","BASELINE_CENTER","BASELINE_RIGHT")
	For i = 0 To alignlst.Size -1
		Main.cmbalign.Items.Add(alignlst.Get(i))
	Next
End Sub
Public Sub get_font_index(strfont As String)  As Int
	Dim fntlst As List = fx.GetAllFontFamilies
	For i = 0 To fntlst.Size -1
		Dim fntname As String = fntlst.Get(i)
		If fntname = strfont Then Return i
	Next
	Return 0
End Sub
Public Sub get_align_index(stralign As String) As Int
	Dim alignlst As List = Array As String("TOP_LEFT","TOP_CENTER","TOP_RIGHT", _
										   "CENTER_LEFT","CENTER","CENTER_RIGHT", _
										   "BOTTOM_LEFT","BOTTOM_CENTER","BOTTOM_RIGHT", _
										   "BASELINE_LEFT","BASELINE_CENTER","BASELINE_RIGHT")
	For i = 0 To alignlst.Size -1
		If alignlst.Get(i) = stralign Then Return i
	Next
	Return 0
End Sub

Public Sub clrpick_ValueChanged (Value As Paint)
	If Main.currnode.IsInitialized = True Then
		Dim td As tagdata = Main.currnode.Tag
		td.backcolor = xui.PaintOrColorToColor(Value)
		If td.gradient1 <> Null And td.gradient2 <> Null And td.gradient1 <> "null" And td.gradient2 <> "null" Then
			If td.gradienthorz = True Then
				CSSUtils.SetStyleProperty(Main.currnode,"-fx-background-color","linear-gradient(to right,"& td.gradient1 & "," & td.gradient2 & ")")
			Else
				CSSUtils.SetStyleProperty(Main.currnode,"-fx-background-color","linear-gradient(to bottom,"& td.gradient1 & "," & td.gradient2 & ")")						
			End If
		Else
			CSSUtils.SetBackgroundColor(Main.currnode, Value)				
		End If
		Main.currnode.Tag = td
	End If
End Sub
Public Sub spinthick_ValueChanged (Value As Object)
	If Main.currnode.IsInitialized = True Then
		Dim td As tagdata = Main.currnode.Tag
		td.brdthick = Value
		CSSUtils.SetBorder(Main.currnode,Value,Main.borderclr.SelectedColor,Main.spinradius.Value)
		Main.currnode.Tag = td
	End If
End Sub
Public Sub spinradius_ValueChanged (Value As Object)
	If Main.currnode.IsInitialized = True Then
		Dim td As tagdata = Main.currnode.Tag
		td.brdradius = Value
		CSSUtils.SetBorder(Main.currnode,Main.spinthick.Value,Main.borderclr.SelectedColor,Value)
		Main.currnode.Tag = td
	End If
End Sub
Public Sub borderclr_ValueChanged (Value As Paint)
	If Main.currnode.IsInitialized = True Then
		Dim td As tagdata = Main.currnode.Tag
		td.brdcolor = xui.PaintOrColorToColor(Value)
		CSSUtils.SetBorder(Main.currnode,Main.spinthick.Value,Value,Main.spinradius.Value)
		Main.currnode.Tag = td
	End If
End Sub
Public Sub cboxborder_CheckedChange(Checked As Boolean)
	If Main.currnode.IsInitialized = True Then
		If Checked Then
			Dim td As tagdata = Main.currnode.Tag
			CSSUtils.SetBorder(Main.currnode,0,fx.Colors.Black,0)
			td.noborder = True
			Main.currnode.Tag = td
		Else
			Dim td As tagdata = Main.currnode.Tag
			CSSUtils.SetBorder(Main.currnode,td.brdthick,fx.Colors.From32Bit(td.brdcolor),td.brdradius)
			td.noborder = False
			Main.currnode.Tag = td
		End If
	End If
End Sub
Public Sub cboxfill_CheckedChange(Checked As Boolean)
	If Main.currnode.IsInitialized = True Then
		If Checked Then
			Dim td As tagdata = Main.currnode.Tag
			If td.comptype = "Canvas" Then
				td.nofill = True
				pane_module.set_canvas_drawing(Main.currnode,td.drawing,td)
				Main.currnode.Tag = td
			End If
		Else
			Dim td As tagdata = Main.currnode.Tag
			If td.comptype = "Canvas" Then
				td.nofill = False
				pane_module.set_canvas_drawing(Main.currnode,td.drawing,td)
				Main.currnode.Tag = td
			End If
		End If
	End If
End Sub
Public Sub btnimgselect_Click
	If Main.currnode.IsInitialized = False Then Return
	Dim td As tagdata = Main.currnode.Tag
	Dim img As String = ""
		img = Main.select_image
	If img <> "" Then
		CSSUtils.SetBackgroundImage(Main.currnode,Main.imagefilesfolder,img)
		td.imgurl = Main.imagefilesfolder & "/" & img
		Main.currnode.Tag = td
	End If
End Sub
Public Sub btnsettext_Click
	If Main.currnode.IsInitialized = False Then Return
	Dim td As tagdata = Main.currnode.Tag
	If td.id.Contains("Label") Or td.id.Contains("Button") Then
			Dim albl As Label = Main.currnode
			Wait for(Main.get_new_text(albl)) Complete (Result As String)
			albl.Text = Result
	End If
	If td.id.Contains("Canvas") Then
		If td.drawing <> Null And td.drawing = "text" Then
			Dim albl As Label
			albl.Initialize("")
			Wait for(Main.get_new_text(albl)) Complete (Result As String)
			Dim pnl As Pane = Main.currnode
			pnl.RemoveAllNodes
			Dim pcnvs As B4XCanvas
			pcnvs.Initialize(pnl)
			Dim fnt As B4XFont = fx.CreateFont(td.fontfamily,td.fontsize,td.isbold,td.isitalic)
			pcnvs.DrawText(Result,pnl.PrefWidth/2,pnl.PrefHeight/2,fnt,xui.Color_Black,"CENTER")
			pcnvs.Invalidate
			td.drawingtext = Result
			Main.currnode.Tag = td
		End If
	End If
End Sub
Public Sub btnimgremove_Click
	If Main.currnode.IsInitialized = True Then
		Dim td As tagdata = Main.currnode.Tag
		td.imgurl = ""
		CSSUtils.SetBackgroundImage(Main.currnode,Main.imagefilesfolder,"")
		Main.currnode.Tag = td
	End If
End Sub
Public Sub textclr_ValueChanged (Value As Paint)
	If Main.currnode.IsInitialized = True Then
		Dim td As tagdata = Main.currnode.Tag
		td.textcolor = xui.PaintOrColorToColor(Value)
		Main.currnode.TextColor = xui.PaintOrColorToColor(Value)
		Main.currnode.Tag = td
	End If
End Sub
Public Sub spinsize_ValueChanged (Value As Object)
	If Main.currnode.IsInitialized = True Then
		Dim td As tagdata = Main.currnode.Tag
		td.fontsize = Value
		CSSUtils.SetStyleProperty(Main.currnode,"-fx-font-size",Value)
		Main.currnode.Tag = td
	End If
End Sub
Public Sub cmbfont_ValueChanged (Value As Object)
	If Main.currnode.IsInitialized = True Then
		Dim td As tagdata = Main.currnode.Tag
		td.fontfamily = Value
		CSSUtils.SetStyleProperty(Main.currnode,"-fx-font-family",Value)
		Main.currnode.Tag = td
	End If
End Sub
Public Sub cmbfont_SelectedIndexChanged(Index As Int, Value As Object)
	If Main.currnode.IsInitialized = True Then
		Dim td As tagdata = Main.currnode.Tag
		td.fontfamily = Value
		CSSUtils.SetStyleProperty(Main.currnode,"-fx-font-family",Value)
		Main.currnode.Tag = td
	End If
End Sub
Public Sub cboxitalic_CheckedChange(Checked As Boolean)
	If Main.currnode.IsInitialized = True Then
		If Checked Then
			Dim td As tagdata = Main.currnode.Tag
			td.isitalic = "true"
			CSSUtils.SetStyleProperty(Main.currnode,"-fx-font-style","italic")
			Main.currnode.Tag = td
		Else
			Dim td As tagdata = Main.currnode.Tag
			td.isitalic = "false"
			CSSUtils.SetStyleProperty(Main.currnode,"-fx-font-style","normal")
			Main.currnode.Tag = td
		End If
	End If
End Sub
Public Sub cboxbold_CheckedChange(Checked As Boolean)
	If Main.currnode.IsInitialized = True Then
		If Checked Then
			Dim td As tagdata = Main.currnode.Tag
			td.isbold = "true"
			CSSUtils.SetStyleProperty(Main.currnode,"-fx-font-weight","bold")
			Main.currnode.Tag = td
		Else
			Dim td As tagdata = Main.currnode.Tag
			td.isbold = "false"
			CSSUtils.SetStyleProperty(Main.currnode,"-fx-font-weight","normal")
			Main.currnode.Tag = td
		End If
	End If
End Sub
Public Sub cmbalign_ValueChanged (Value As Object)
	If Main.currnode.IsInitialized = True Then
		Dim td As tagdata = Main.currnode.Tag
		If td.id.Contains("Label") Then
			td.alignment = Value
			Main.currlabel.Alignment = Value
			Main.currnode.Tag = td
		End If
	End If
End Sub
Public Sub cmbalign_SelectedIndexChanged(Index As Int, Value As Object)
	If Main.currnode.IsInitialized = True Then
		Dim td As tagdata = Main.currnode.Tag
		If td.id.Contains("Label") Then
			td.alignment = Value
			Main.currlabel.Alignment = Value
			Main.currnode.Tag = td
		End If
	End If
End Sub

Public Sub tfleft_TextChanged (Old As String, New As String)
	If IsNumber(New) = False Then Return
	If New = "" Then New = 0
	'If New > currnode.Left + currnode.Width Then New = panemain.Width - currnode.Width
	If Main.currnode.IsInitialized = True Then
		Main.currnode.left = New
	End If
End Sub
Public Sub tftop_TextChanged (Old As String, New As String)
	If IsNumber(New) = False Then Return
	If New = "" Then New = 0
	'If New > currnode.Top + currnode.Height Then New = panemain.Height - currnode.Height
	If Main.currnode.IsInitialized = True Then
		Main.currnode.Top = New
	End If
End Sub
Public Sub tfwidth_TextChanged (Old As String, New As String)
	If IsNumber(New) = False Then Return
	If New = "" Then New = 20
	'If New > panemain.Width - currnode.Width Then New = Old
	If Main.currnode.IsInitialized = True Then
		Main.currnode.Width = New
	End If
End Sub
Public Sub tfheight_TextChanged (Old As String, New As String)
	If IsNumber(New) = False Then Return
	If New = "" Then New = 20
	'If New > panemain.Height - currnode.Height Then New = Old
	If Main.currnode.IsInitialized = True Then
		Main.currnode.Height = New
	End If
End Sub

Public Sub btncolor1_Click
	Main.pncolornames.Visible = True
	Main.pncompinfo.Visible = False
	Main.btncolorclicked = "color1"
	If IsNumber(Main.lblgradient1.Text) Then Main.clvnamedcolors.ScrollToItem(Main.lblgradient1.Text-1)
End Sub
Public Sub btncolor2_Click
	Main.pncolornames.Visible = True
	Main.pncompinfo.Visible = False
	Main.btncolorclicked = "color2"
	If IsNumber(Main.lblgradient2.Text) Then Main.clvnamedcolors.ScrollToItem(Main.lblgradient2.Text-1)
End Sub
Public Sub clvnamedcolors_ItemClick (Index As Int, Value As Object)
	If Main.btncolorclicked = "color1" Then
		Main.gradient1 = Value
		Main.lblgradient1.Style = "-fx-background-color:" & Value
		Main.lblgradient1.Text = Index+1
	Else
		Main.gradient2 = Value
		Main.lblgradient2.Style = "-fx-background-color:" & Value
		Main.lblgradient2.Text = Index+1
	End If
	Main.pncolornames.Visible = False
	Main.pncompinfo.Visible = True
	If Main.currnode.IsInitialized = True Then
		Dim td As tagdata = Main.currnode.Tag
		td.gradient1 = Main.gradient1
		td.gradient2 = Main.gradient2
		If Main.cboxhorz.Checked = True Then
			td.gradienthorz = True
			CSSUtils.SetStyleProperty(Main.currnode,"-fx-background-color","linear-gradient(to right,"& td.gradient1 & "," & td.gradient2 & ")")
		Else
			td.gradienthorz = False
			CSSUtils.SetStyleProperty(Main.currnode,"-fx-background-color","linear-gradient(to bottom,"& td.gradient1 & "," & td.gradient2 & ")")
		End If
		Main.currnode.Tag = td
	End If
End Sub
Public Sub cboxhorz_CheckedChange(Checked As Boolean)
	If Main.currnode.IsInitialized = True Then
		Dim td As tagdata = Main.currnode.Tag
		If Main.cboxhorz.Checked = True Then
			td.gradienthorz = True
			CSSUtils.SetStyleProperty(Main.currnode,"-fx-background-color","linear-gradient(to right,"& td.gradient1 & "," & td.gradient2 & ")")
		Else
			td.gradienthorz = False
			CSSUtils.SetStyleProperty(Main.currnode,"-fx-background-color","linear-gradient(to bottom,"& td.gradient1 & "," & td.gradient2 & ")")
		End If
		Main.currnode.Tag = td
	End If
End Sub
Public Sub btnclose_Click
	Main.pncolornames.Visible = False
	Main.pncompinfo.Visible = True
End Sub
Public Sub cboxnogradient_CheckedChange(Checked As Boolean)
	If Main.currnode.IsInitialized = True Then
		If Checked Then
			Dim td As tagdata = Main.currnode.Tag
			If td.gradient1 <> Null Or td.gradient2 <> Null Then
				td.gradient1 = "null"
				td.gradient2 = "null"
				td.gradienthorz = "false"
				CSSUtils.SetStyleProperty(Main.currnode,"-fx-background-color","white")
				Main.currnode.Tag = td
				Main.lblgradient1.Style = "-fx-background-color:white"
				Main.lblgradient2.Style = "-fx-background-color:white"
				Main.cboxnogradient.Checked = False				
			End If
		End If
	End If
End Sub

Public Sub fill_tv1
	Main.tv1.Root.Children.Clear
	Main.tv1.Root.Expanded = True
	For Each nod As Node In Main.panemain.GetAllViewsRecursive
		If nod.Tag <> "" Then
			Dim td As tagdata = nod.Tag
			Dim id As String = td.id
			If id.Contains("Pane") Then
				Dim ti As TreeItem
				ti.Initialize("ti",id)
				ti.Expanded = True
				ti = add_children(ti,id)		' get possible children
				Main.tv1.Root.Children.Add(ti)
			Else
				If td.parent = Null Or td.parent = "null" Then
					Dim ti As TreeItem
					ti.Initialize("ti",id)
					ti.Expanded = True
					Main.tv1.Root.Children.Add(ti)
				End If
			End If					
		End If
	Next
End Sub
Private Sub add_children(pti As TreeItem, pstr As String) As TreeItem
	Dim newpti As TreeItem
	newpti.Initialize("ti",pti.Text)
	For Each nod As Node In Main.panemain.GetAllViewsRecursive
		If nod.Tag <> "" Then
			Dim td As tagdata = nod.Tag
			Dim id As String = td.id
			If td.parent <> Null And td.parent = pstr Then
				Dim ti As TreeItem
				ti.Initialize("ti",id)
				ti.Expanded = True
				newpti.Children.Add(ti)
			End If
		End If
	Next
	Return newpti
End Sub
Public Sub tv1_SelectedItemChanged (SelectedItem As TreeItem)
	If SelectedItem.IsInitialized = False Then Return
	If Main.currnode.IsInitialized = True Then
		For Each nod As Node In Main.panemain.GetAllViewsRecursive
			If nod.Tag <> "" Then
				Dim td As tagdata = nod.Tag
				If td.id = SelectedItem.Text Then
					Main.currnode =  nod
					If td.id.Contains("Label") Or td.id.Contains("Button") Then
						Main.currlabel =  nod
						Main.show_component_info(Main.currlabel)
					End If
					If td.id.Contains("Pane") Or td.id.Contains("Canvas") Then
						Main.currpane =  nod
						Main.show_component_info(Main.currpane)
						If td.id.Contains("Canvas") Then
							td = pane_module.set_canvas_drawing(Main.currpane,td.drawing,td)
						End If
					End If
				End If
			End If
		Next
	End If
End Sub

Public Sub fill_component_list
	Main.clvcomplist.Clear
	childrenlist.Initialize
	For Each nod As Node In Main.panemain.GetAllViewsRecursive
		If nod.Tag <> "" Then
			Dim td As tagdata = nod.Tag
			Dim pn As Pane = set_component_list_item(td)
			Main.clvcomplist.Add(pn,td.id)
		End If
	Next
End Sub
Private Sub set_component_list_item(td As tagdata) As Pane
	Dim pn As Pane
	pn.Initialize("")
	pn.LoadLayout("clvcomplistitem_layout")
	pn.SetLayoutAnimated(0, 0, 0, 200, 25)
	lblchild.Text = ""
	If td.parent <> Null And td.parent <> "" And td.parent <> "null" Then
		lblgrchild.Text = ""
		lblidname.Text = ""
		CSSUtils.SetBorder(lblidname,0,fx.Colors.Black,0)
		If childrenlist.ContainsKey(td.parent) Then
			lblchild.Text = ""
			CSSUtils.SetBorder(lblchild,0,fx.Colors.Black,0)
			lblgrchild.Text = " " & td.id
			CSSUtils.SetBorder(lblgrchild,1,fx.Colors.Black,3)
		Else
			lblchild.Text = " " & td.id			
		End If
		childrenlist.Put(td.id,td.parent)
	Else
		lblidname.Text = " " & td.id
		lblchild.Text = ""
		CSSUtils.SetBorder(lblchild,0,fx.Colors.Black,0)
	End If
	Return pn
End Sub
Public Sub clvcomplist_ItemClick (Index As Int, Value As Object)
	If Main.currnode.IsInitialized = True Then
		For Each nod As Node In Main.panemain.GetAllViewsRecursive
			If nod.Tag <> "" Then
				Dim td As tagdata = nod.Tag
				If td.id = Value Then
					Main.currnode =  nod
					If td.id.Contains("Label") Or td.id.Contains("Button") Then
						Main.currlabel =  nod
						Main.currnode = nod
						Main.show_component_info(Main.currlabel)
						Main.show_yellow_border(td)
					End If
					If td.id.Contains("Pane") Or td.id.Contains("Canvas") Then
						Main.currpane =  nod
						Main.currnode = nod
						Main.show_component_info(Main.currpane)
						If td.id.Contains("Canvas") Then
							td = pane_module.set_canvas_drawing(Main.currpane,td.drawing,td)
						End If
						Main.show_yellow_border(td)
					End If
				End If
			End If
		Next
	End If
End Sub
Public Sub clvcomplist_ItemLongClick (Index As Int, Value As Object)
	Dim defaultitemheight As Int = Main.clvcomplist.GetPanel(0).Height
	For Each k As String In childrenlist.Keys
		If childrenlist.Get(k) = Value Then
			For i = 0 To Main.clvcomplist.Size -1
				Dim itemheight As Int = Main.clvcomplist.GetPanel(i).Height
				'Log("default " & defaultitemheight)
				'Log("item " & itemheight)
				If itemheight > 0 And itemheight <= defaultitemheight Then
					If Main.clvcomplist.GetValue(i) = k Then
						If childrenlist.ContainsKey(Main.clvcomplist.GetValue(i)) Then
							'Log(Main.clvcomplist.GetValue(i))
							collapse_grandchildren(Main.clvcomplist.GetValue(i))
						End If
						Main.clvcomplist.ResizeItem(i,0)
					End If
				End If
			Next
		End If
	Next
End Sub
Private Sub collapse_grandchildren(parent As String)
	For Each k As String In childrenlist.Keys
		If childrenlist.Get(k) = parent Then
			For i = 0 To Main.clvcomplist.Size -1
				If Main.clvcomplist.GetValue(i) = k Then
					Main.clvcomplist.ResizeItem(i,0)
				End If
			Next
		End If
	Next
End Sub