﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.8
@EndOfDesignText@
Sub Process_Globals
	Private fx As JFX
	Private xui As XUI
End Sub

Public Sub add_new_component(comptype As String) As Node
	Dim currparent As String = "null"
	Dim parentnode As Node
	'parentnode.Initialize("")
	Dim llst As List
	llst.Initialize
	llst = File.ReadList(File.DirAssets,comptype & "_default.sld")
	For i = 0 To llst.Size - 1
		Dim valstr As String = llst.Get(i)
		Dim valuesmap As Map = valstr.As(JSON).ToMap
		Dim td As tagdata
		td.PressedX = valuesmap.Get("pressedx")
		td.PressedY = valuesmap.Get("pressedy")
		td.count = Main.nodecnt			'valuesmap.Get("count")
		td.id = valuesmap.Get("id")
		td.imgurl = valuesmap.Get("imgurl")
		td.backcolor = valuesmap.Get("backcolor")
		td.brdthick = valuesmap.Get("brdthick")
		td.brdcolor = valuesmap.Get("brdcolor")
		td.brdradius = valuesmap.Get("brdradius")
		td.noborder = valuesmap.Get("noborder")
		td.fontfamily = valuesmap.Get("fontfamily")
		td.fontsize = valuesmap.Get("fontsize")
		td.isbold = valuesmap.Get("isbold")
		td.isitalic = valuesmap.Get("isitalic")
		td.alignment = valuesmap.Get("alignment")
		td.textcolor = valuesmap.Get("textcolor")
		td.parent = currparent			'valuesmap.Get("parent")
		td.drawing = valuesmap.Get("drawing")
		td.drawingtext = valuesmap.Get("drawingtext")
		td.gradient1 = valuesmap.Get("gradient1")
		td.gradient2 = valuesmap.Get("gradient2")
		If valuesmap.Get("gradienthorz") <> Null Then
			td.gradienthorz = valuesmap.Get("gradienthorz")
		End If
		td.comptype = valuesmap.Get("comptype")
		If td.id.Contains("Label") Then
			td.id = "Label" & td.count
		End If
		If td.id.Contains("Button") Then
			td.id = "Button" & td.count
		End If
		If td.id.Contains("Pane") Then
			td.id = "Pane" & td.count
			td.comptype = comptype
			currparent = td.id
		End If
		If td.id.Contains("Canvas") Then
			td.id = "Canvas" & td.count
		End If
		If td.id.Contains("Label") Or td.id.Contains("Button") Then
			label_module.load_label(td,valuesmap)
		Else
			pane_module.load_pane(td,valuesmap)
		End If
		Main.nodecnt = Main.nodecnt + 1
	Next
	For Each nod As Node In Main.panemain.GetAllViewsRecursive
		If nod.Tag <> "" Then
			Dim td As tagdata = nod.Tag
			If td.id.Contains("Pane") Then
				parentnode = nod
				Main.attach_children(td.id,nod)
			End If
		End If
	Next
	Return parentnode
End Sub

Public Sub fill_currvalues(nod As Node) As Map
	If nod.Tag <> "" Then
		Dim td As tagdata
		td = nod.tag
		Dim valuemap As Map
		valuemap.Initialize
		valuemap.Put("top",nod.Top)
		valuemap.Put("left",nod.Left)
		valuemap.Put("width",nod.PrefWidth)
		valuemap.Put("height",nod.PrefHeight)
		If td.id.Contains("Label") Or td.id.Contains("Button") Then
			Dim strtxt As String = nod.As(Label).Text
			strtxt = strtxt.Replace(Chr(10),"&lf;")
			strtxt = strtxt.Replace("""","&quote;")
			strtxt = strtxt.Replace(",","&comma;")
		Else
			strtxt = ""
		End If
		valuemap.Put("text",strtxt)
		valuemap.Put("pressedx",td.PressedX)
		valuemap.Put("pressedy",td.PressedY)
		valuemap.Put("count",td.count)
		valuemap.Put("id",td.id)
		If td.imgurl <> Null Then
			Dim strurl As String = td.imgurl
			strurl = strurl.Replace("\","/")
			valuemap.Put("imgurl",strurl)
		Else
			valuemap.Put("imgurl",td.imgurl)
		End If
		valuemap.Put("backcolor",td.backcolor)
		valuemap.Put("brdthick",td.brdthick)
		valuemap.Put("brdcolor",td.brdcolor)
		valuemap.Put("brdradius",td.brdradius)
		Dim nobord As String
		If td.noborder = False Then
			nobord = "false"
		Else
			nobord = "true"
		End If
		valuemap.Put("noborder",nobord)
		valuemap.Put("fontfamily",td.fontfamily)
		valuemap.Put("fontsize",td.fontsize)
		valuemap.Put("isbold",td.isbold)
		valuemap.Put("isitalic",td.isitalic)
		valuemap.Put("alignment",td.alignment)
		valuemap.Put("textcolor",td.textcolor)
		valuemap.Put("parent",td.parent)
		valuemap.Put("drawing",td.drawing)
		valuemap.Put("drawingtext",td.drawingtext)
		valuemap.Put("gradient1",td.gradient1)
		valuemap.Put("gradient2",td.gradient2)
		valuemap.Put("gradienthorz",td.gradienthorz)
		valuemap.Put("comptype",td.comptype)
		Dim nofill As String
		If td.nofill = False Then
			nofill = "false"
		Else
			nofill = "true"
		End If
		valuemap.Put("nofill",nofill)
		' save the children in a temp file
		Return valuemap
	End If
	Return Null
End Sub

Public Sub put_currvalues_into_node(newnod As Node) As Node
	Dim newtd As tagdata = newnod.tag
	Dim td As tagdata
	td.PressedX = newtd.PressedX
	td.PressedY = newtd.PressedY
	td.count = newtd.count
	td.id = newtd.id
	td.imgurl = Main.currvalues.Get("imgurl")
	td.backcolor = Main.currvalues.Get("backcolor")
	td.brdthick = Main.currvalues.Get("brdthick")
	td.brdcolor = Main.currvalues.Get("brdcolor")
	td.brdradius = Main.currvalues.Get("brdradius")
	Dim strnoborder As String = Main.currvalues.Get("noborder")
	If strnoborder = "false" Then
		td.noborder = False
	Else
		td.noborder = True	
	End If
	td.fontfamily = Main.currvalues.Get("fontfamily")
	td.fontsize = Main.currvalues.Get("fontsize")
	Dim strisbold As String = Main.currvalues.Get("isbold")
	If strisbold = "false" Then
		td.isbold = False
	Else
		td.isbold = True	
	End If
	Dim strisitalic As String = Main.currvalues.Get("isitalic")
	If strisitalic = "false" Then
		td.isitalic = False
	Else
		td.isitalic = True
	End If
	td.alignment = Main.currvalues.Get("alignment")
	td.textcolor = Main.currvalues.Get("textcolor")
	td.parent = Main.currvalues.Get("parent")
	td.drawing = Main.currvalues.Get("drawing")
	td.drawingtext = Main.currvalues.Get("drawingtext")
	td.gradient1 = Main.currvalues.Get("gradient1")
	td.gradient2 = Main.currvalues.Get("gradient2")
	If Main.currvalues.Get("gradienthorz") <> Null Then
		Dim strgradienthorz As String = Main.currvalues.Get("gradienthorz")
		If strgradienthorz = "false" Then
			td.gradienthorz = False
		Else
			td.gradienthorz = True
		End If
	End If
	td.comptype = Main.currvalues.Get("comptype")
	If Main.currvalues.ContainsKey("nofill") Then
		Dim strnofill As String = Main.currvalues.Get("nofill")
		If strnofill = "false" Then
			td.nofill = False
		Else
			td.nofill = True
		End If
	End If
	If td.id.Contains("Label") Or td.id.Contains("Button") Then
		label_module.load_label(td,Main.currvalues)
	Else
		pane_module.load_pane(td,Main.currvalues)
	End If
	For Each nod As Node In Main.panemain.GetAllViewsRecursive
		If nod.Tag <> "" Then
			Dim td As tagdata = nod.Tag
			If td.id.Contains("Pane") Then
				Main.attach_children(td.id,nod)
			End If
		End If
	Next
	newnod.Tag = td
	Dim comptype As String = td.comptype
	If Main.templst.Size > 0 Then
		For i = 0 To Main.templst.Size -1
			Dim valuesmap As Map = Main.templst.Get(i)
			Dim td As tagdata
			td.PressedX = valuesmap.Get("pressedx")
			td.PressedY = valuesmap.Get("pressedy")
			td.count = Main.nodecnt			'valuesmap.Get("count")
			td.id = valuesmap.Get("id")
			td.imgurl = valuesmap.Get("imgurl")
			td.backcolor = valuesmap.Get("backcolor")
			td.brdthick = valuesmap.Get("brdthick")
			td.brdcolor = valuesmap.Get("brdcolor")
			td.brdradius = valuesmap.Get("brdradius")
			td.noborder = valuesmap.Get("noborder")
			td.fontfamily = valuesmap.Get("fontfamily")
			td.fontsize = valuesmap.Get("fontsize")
			td.isbold = valuesmap.Get("isbold")
			td.isitalic = valuesmap.Get("isitalic")
			td.alignment = valuesmap.Get("alignment")
			td.textcolor = valuesmap.Get("textcolor")
			td.parent = newnod.Id		'currparent			'valuesmap.Get("parent")
			td.drawing = valuesmap.Get("drawing")
			td.drawingtext = valuesmap.Get("drawingtext")
			td.gradient1 = valuesmap.Get("gradient1")
			td.gradient2 = valuesmap.Get("gradient2")
			If valuesmap.Get("gradienthorz") <> Null Then
				td.gradienthorz = valuesmap.Get("gradienthorz")
			End If
			td.comptype = valuesmap.Get("comptype")
			If td.id.Contains("Label") Then
				td.id = "Label" & td.count
			End If
			If td.id.Contains("Button") Then
				td.id = "Button" & td.count
			End If
			If td.id.Contains("Pane") Then
				td.id = "Pane" & td.count
				td.comptype = comptype
			End If
			If td.id.Contains("Canvas") Then
				td.id = "Canvas" & td.count
			End If
			If td.id.Contains("Label") Or td.id.Contains("Button") Then
				label_module.load_label(td,valuesmap)
			Else
				pane_module.load_pane(td,valuesmap)
			End If
			Main.nodecnt = Main.nodecnt + 1
		Next
	End If
	For Each nod As Node In Main.panemain.GetAllViewsRecursive
		If nod.Tag <> "" Then
			Dim td As tagdata = nod.Tag
			If td.id.Contains("Pane") Then
				If td.id = newnod.Id Then
					Main.attach_children(td.id,nod)
				End If
			End If
		End If
	Next
	Return newnod
End Sub