﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.8
@EndOfDesignText@
Sub Process_Globals
	Private fx As JFX
	Private xui As XUI
End Sub

Public Sub draw_arrow_up(cnvs As B4XCanvas,pn As Pane,td As tagdata)
	If td.nofill = True Then
		cnvs.DrawLine(10,0,10,pn.prefHeight,td.brdcolor,td.brdthick)
		cnvs.DrawLine(0,20,10,0,td.brdcolor,td.brdthick)
		cnvs.DrawLine(10,0,20,20,td.brdcolor,td.brdthick)
	Else
		Dim path As B4XPath
		path.Initialize(10,0)
		path.LineTo(20,20)
		path.LineTo(10,15)
		path.LineTo(0,20)
		cnvs.DrawPath(path,td.brdcolor,True,td.brdthick)
		cnvs.DrawLine(10,0,10,pn.prefHeight,td.brdcolor,td.brdthick)		
	End If
End Sub
Public Sub draw_arrow_down(cnvs As B4XCanvas,pn As Pane,td As tagdata)
	If td.nofill = True Then
		cnvs.DrawLine(10,0,10,pn.prefHeight,td.brdcolor,td.brdthick)
		cnvs.DrawLine(10,pn.prefHeight,0,pn.prefHeight-20,td.brdcolor,td.brdthick)
		cnvs.DrawLine(10,pn.prefHeight,20,pn.prefHeight-20,td.brdcolor,td.brdthick)
	Else
		Dim path As B4XPath
		path.Initialize(10,pn.prefHeight)
		path.LineTo(0,pn.prefHeight-20)
		path.LineTo(10,pn.prefHeight-15)
		path.LineTo(20,pn.prefHeight-20)
		cnvs.DrawPath(path,td.brdcolor,True,td.brdthick)
		cnvs.DrawLine(10,0,10,pn.prefHeight,td.brdcolor,td.brdthick)
	End If
End Sub
Public Sub draw_arrow_left(cnvs As B4XCanvas,pn As Pane,td As tagdata)
	If td.nofill = True Then
		cnvs.DrawLine(0,10,pn.prefWidth,10,td.brdcolor,td.brdthick)
		cnvs.DrawLine(0,10,20,0,td.brdcolor,td.brdthick)
		cnvs.DrawLine(0,10,20,20,td.brdcolor,td.brdthick)
	Else
		Dim path As B4XPath
		path.Initialize(0,10)
		path.LineTo(20,0)
		path.LineTo(15,10)
		path.LineTo(20,20)
		cnvs.DrawPath(path,td.brdcolor,True,td.brdthick)
		cnvs.DrawLine(0,10,pn.prefWidth,10,td.brdcolor,td.brdthick)			
	End If
End Sub
Public Sub draw_arrow_right(cnvs As B4XCanvas,pn As Pane,td As tagdata)
	If td.nofill = True Then
		cnvs.DrawLine(0,10,pn.prefWidth,10,td.brdcolor,td.brdthick)
		cnvs.DrawLine(pn.prefWidth,10,pn.prefWidth-20,0,td.brdcolor,td.brdthick)
		cnvs.DrawLine(pn.prefWidth,10,pn.prefWidth-20,20,td.brdcolor,td.brdthick)
	Else
		Dim path As B4XPath
		path.Initialize(pn.prefWidth,10)
		path.LineTo(pn.prefWidth-20,20)
		path.LineTo(pn.prefWidth-15,10)
		path.LineTo(pn.prefWidth-20,0)
		cnvs.DrawPath(path,td.brdcolor,True,td.brdthick)
		cnvs.DrawLine(0,10,pn.prefWidth,10,td.brdcolor,td.brdthick)	
	End If
End Sub
Public Sub draw_bitmap(cnvs As B4XCanvas,pn As Pane,td As tagdata,action As String)
	If action = "add" Then
		Dim rect As B4XRect
		rect.Width = pn.PrefWidth
		rect.Height = pn.PrefHeight
		Dim bmp As Image
		bmp.Initialize(File.DirAssets, "bitmap.png")		' default bitmap
		cnvs.DrawBitmap(bmp, rect)
		Main.oldbitmapname = "bitmap.png"
	Else
		Dim fname As String = td.imgurl.SubString(td.imgurl.LastIndexOf("/")+1)
		If Main.oldbitmapname <> fname Then
			Dim rect As B4XRect
			rect.Width = pn.PrefWidth
			rect.Height = pn.PrefHeight
			Dim bmp As Image
			If td.imgurl <> "" And File.Exists(Main.imagefilesfolder, fname) Then
				bmp.Initialize(Main.imagefilesfolder, fname)
				Main.oldbitmapname = fname
			Else
				bmp.Initialize(File.DirAssets, "bitmap.png")
				Main.oldbitmapname = "bitmap.png"
			End If
			cnvs.DrawBitmap(bmp, rect)
		End If		
	End If
End Sub
Public Sub draw_circle(cnvs As B4XCanvas,pn As Pane,td As tagdata)
	If td.nofill = True Then
		cnvs.DrawCircle((pn.PrefWidth/2),(pn.PrefHeight/2),(pn.PrefHeight/2)-(td.brdthick*3),td.brdcolor,False,td.brdthick)
	Else
		cnvs.DrawCircle((pn.PrefWidth/2),(pn.PrefHeight/2),(pn.PrefHeight/2)-(td.brdthick*3),td.brdcolor,True,td.brdthick)
	End If
End Sub
Public Sub draw_diamond(cnvs As B4XCanvas,pn As Pane,td As tagdata)
	Dim path As B4XPath
	path.Initialize(pn.PrefWidth/2,0)
	path.LineTo(pn.PrefWidth,pn.PrefHeight/2)
	path.LineTo(pn.PrefWidth/2,pn.PrefHeight)
	path.LineTo(0,pn.PrefHeight/2)
	path.LineTo(pn.PrefWidth/2,0)
	If td.nofill = True Then
		cnvs.DrawPath(path,td.brdcolor,False,td.brdthick)
	Else
		cnvs.DrawPath(path,td.brdcolor,True,td.brdthick)
	End If
End Sub
Public Sub draw_Hline(cnvs As B4XCanvas,pn As Pane,td As tagdata)
	cnvs.DrawLine(0,1,pn.prefWidth,1,td.brdcolor,td.brdthick)
End Sub
Public Sub draw_Vline(cnvs As B4XCanvas,pn As Pane,td As tagdata)
	cnvs.DrawLine(0,0,0,pn.PrefHeight,td.brdcolor,td.brdthick)
End Sub
Public Sub draw_rectangle(cnvs As B4XCanvas,pn As Pane,td As tagdata)
	Dim rect As B4XRect
	rect.Width = pn.PrefWidth
	rect.Height = pn.PrefHeight
	If td.nofill = True Then
		cnvs.DrawRect(rect,td.brdcolor,False,td.brdthick)
	Else
		cnvs.DrawRect(rect,td.brdcolor,True,td.brdthick)
	End If
End Sub
Public Sub draw_text(cnvs As B4XCanvas,pn As Pane,td As tagdata,action As String)
	If action = "add" Then
		Dim fnt As B4XFont = fx.CreateFont(td.fontfamily,td.fontsize,td.isbold,td.isitalic)
		cnvs.DrawText("This is a text!",pn.PrefWidth/2,pn.PrefHeight/2,fnt,td.textcolor,"CENTER")
		td.drawingtext = "This is a text!"
		' show a red border to highlight the text position
		td.noborder = False
		td.brdthick = 5
		td.brdcolor = xui.Color_Red
	Else
		pn.RemoveAllNodes
		Dim ncnvs As B4XCanvas
		ncnvs.Initialize(pn)
		Dim fnt As B4XFont = fx.CreateFont(td.fontfamily,td.fontsize,td.isbold,td.isitalic)
		ncnvs.DrawText(td.drawingtext,pn.PrefWidth/2,pn.PrefHeight/2,fnt,td.textcolor,"CENTER")
		ncnvs.Invalidate
	End If
End Sub
