﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.8
@EndOfDesignText@
Sub Process_Globals
	Private fx As JFX
	Private xui As XUI
	Public pressedX As Double
	Public pressedY As Double
End Sub

Public Sub add_new_label(comptype As String) As Node
	Main.panepressed = False
	Dim td As tagdata
	td.PressedX = 0
	td.PressedY = 0
	td.count = Main.nodecnt
	td.id = comptype & Main.nodecnt
	Dim newlbl As Label
	newlbl.Initialize("lbl")
	newlbl.SetSize(100,40)
	newlbl.Top = 20
	newlbl.Left = 20
	newlbl.Text = comptype & Main.nodecnt
	newlbl.Id = comptype & Main.nodecnt
	newlbl.Font = fx.CreateFont("Verdana",15,False,False)
	newlbl.Alignment = "CENTER"
	newlbl.WrapText = True
	CSSUtils.SetBorder(newlbl,1,fx.Colors.Black,3)
	Dim red As Int = Rnd(150,250)
	Dim green As Int = Rnd(150,250)
	Dim blue As Int = Rnd(150,250)
	CSSUtils.SetBackgroundColor(newlbl, fx.Colors.ARGB(255,red,green,blue))
	td.brdthick = 1
	td.brdcolor = xui.PaintOrColorToColor(fx.Colors.Black)
	td.brdradius = 3
	td.backcolor = xui.PaintOrColorToColor(fx.Colors.ARGB(255,red,green,blue))
	td.noborder = False
	td.fontfamily = "Verdana"
	td.fontsize = 15
	td.isbold = "false"
	td.isitalic = "false"
	td.alignment = "CENTER"
	td.textcolor = xui.PaintOrColorToColor(fx.Colors.Black)
	td.imgurl = ""
	td.comptype = comptype
	newlbl.Tag = td
	Main.panemain.AddNode(newlbl,newlbl.Left,newlbl.top,newlbl.prefWidth,newlbl.PrefHeight)		
	Main.nodecnt = Main.nodecnt + 1
	Main.currnode = newlbl
	Return newlbl
End Sub

Public Sub resize_label(ParentX As Double, ParentY As Double)
	Dim gap As Int = 5
	Dim minwidth As Int = Main.edgewidth * 4
	Dim minheight As Int = Main.edgewidth * 4
	If Main.resizing = True Then
		If Main.lxpos > 0 And Main.lypos > 0 Then
			If Main.xpress <= Main.edgewidth Then	' left edge
				If Main.lxpos > ParentX Then	' moving left
					If Main.currlabel.Left - gap > 0 Then
						Main.currlabel.Left = Main.currlabel.Left - gap
						Main.currlabel.prefWidth = Main.currlabel.Width + gap
					End If
				Else	' moving right
					If Main.currlabel.Width - gap > minwidth Then
						Main.currlabel.Left = Main.currlabel.Left + gap
						Main.currlabel.prefWidth = Main.currlabel.Width - gap
					End If
				End If
			End If
			If Main.xpress >= (Main.currlabel.Width - Main.edgewidth) And Main.xpress < Main.currlabel.Width Then	' right edge
				If Main.lxpos > ParentX Then	' moving left
					If Main.currlabel.Width > minwidth Then
						Main.currlabel.prefWidth = Main.currlabel.Width - gap
						Main.xpress = Main.xpress - gap
					End If
				Else	' moving right
					If Main.currlabel.Width + Main.currlabel.Left < Main.panemain.Width Then
						Main.currlabel.prefWidth = Main.currlabel.Width + gap
						Main.xpress = Main.xpress + gap
					End If
				End If
			End If
			If Main.ypress <= Main.edgewidth Then	'top edge
				If Main.lypos > ParentY Then	' moving up
					If Main.currlabel.Top - gap > 0 Then
						Main.currlabel.Top = Main.currlabel.Top - gap
						Main.currlabel.prefHeight = Main.currlabel.Height + gap
					End If
				Else	' moving down
					If Main.currlabel.Height - gap > minheight Then
						Main.currlabel.Top = Main.currlabel.Top + gap
						Main.currlabel.PrefHeight = Main.currlabel.Height - gap
					End If
				End If
			End If
			If Main.ypress >= (Main.currlabel.Height - Main.edgewidth) And Main.ypress < Main.currlabel.Height Then	' bottom edge
				If Main.lypos > ParentY Then	' moving up
					If Main.currlabel.Height > minheight Then
						Main.currlabel.prefHeight = Main.currlabel.Height - gap
						Main.ypress = Main.ypress - gap
					End If
				Else	'moving down
					If Main.currlabel.Height + Main.currlabel.Top < Main.panemain.Height Then
						Main.currlabel.prefHeight = Main.currlabel.Height + gap
						Main.ypress = Main.ypress + gap
					End If
				End If
			End If
		End If
	End If
End Sub

Public Sub load_label(td As tagdata,valuesmap As Map)
	Dim newlbl As Label
	newlbl.Initialize("lbl")
	newlbl.Top = valuesmap.Get("top")
	newlbl.Left = valuesmap.Get("left")
	newlbl.prefwidth = valuesmap.Get("width")
	newlbl.prefheight = valuesmap.Get("height")
	Dim strtxt As String = valuesmap.Get("text")
	strtxt = strtxt.Replace("&lf;",Chr(10))
	strtxt = strtxt.Replace("&quote;","""")
	strtxt = strtxt.Replace("&comma;",",")
	newlbl.Text = strtxt
	newlbl.Tag = td
	newlbl.Id = td.id
	newlbl.WrapText = True
	newlbl.TextColor = fx.Colors.From32Bit(td.textcolor)
	CSSUtils.SetStyleProperty(newlbl,"-fx-font-family",td.fontfamily)
	CSSUtils.SetStyleProperty(newlbl,"-fx-font-size",td.fontsize)
	If td.isitalic = "true" Then
		CSSUtils.SetStyleProperty(newlbl,"-fx-font-style","italic")
	Else
		CSSUtils.SetStyleProperty(newlbl,"-fx-font-style","normal")
	End If
	If td.isbold = "true" Then
		CSSUtils.SetStyleProperty(newlbl,"-fx-font-weight","bold")
	Else
		CSSUtils.SetStyleProperty(newlbl,"-fx-font-weight","normal")
	End If
	newlbl.Alignment = td.alignment
	If td.noborder = "false" Then CSSUtils.SetBorder(newlbl,td.brdthick,fx.Colors.From32Bit(td.brdcolor),td.brdradius)
	If td.gradient1 <> "null" And td.gradient2 <> "null" Then
		If td.gradienthorz = True Then
			CSSUtils.SetStyleProperty(newlbl,"-fx-background-color","linear-gradient(to right,"& td.gradient1 & "," & td.gradient2 & ")")
		Else
			CSSUtils.SetStyleProperty(newlbl,"-fx-background-color","linear-gradient(to bottom,"& td.gradient1 & "," & td.gradient2 & ")")
		End If
	Else
		CSSUtils.SetBackgroundColor(newlbl, fx.Colors.From32Bit(td.backcolor))			
	End If
	If td.imgurl <> "" Then
		Dim folder As String = td.imgurl.SubString2(0,td.imgurl.LastIndexOf("/"))
		Dim fname As String = td.imgurl.SubString(td.imgurl.LastIndexOf("/")+1)
		CSSUtils.SetBackgroundImage(newlbl,folder,fname)
	End If
	Dim vw As B4XView = newlbl
	vw.Rotation = td.rotation
	newlbl = vw
	Main.panemain.AddNode(newlbl,newlbl.Left,newlbl.Top,newlbl.prefWidth,newlbl.prefHeight)
End Sub

Private Sub lbl_MouseClicked(EventData As MouseEvent)
	Dim view As Label = Sender
	Main.currlabel = view
	Main.show_component_info(view)
	Main.currnode = view
End Sub
Private Sub lbl_MouseDragged (EventData As MouseEvent)
	Dim nod As Node = Sender
	Dim td As tagdata = nod.Tag
	Main.panepressed = False
	If td.id.Contains("Pane") Then Return
	If td.parent <> Null And td.parent <> "null"  Then Return
	If Main.resizing = False Then
		' code from xulihang
		Dim event As JavaObject = EventData
		Dim offsetX, offsetY As Double
		offsetX = event.RunMethod("getSceneX",Null) - pressedX
		offsetY =  event.RunMethod("getSceneY",Null)- pressedY
		nod.Left = nod.Left + offsetX
		nod.Top = nod.Top + offsetY
		pressedX = event.RunMethod("getSceneX",Null)
		pressedY = event.RunMethod("getSceneY",Null)
		'
	Else
		nod.As(Label).MouseCursor = fx.Cursors.CLOSED_HAND
		CSSUtils.SetBorder(nod,10,fx.Colors.Blue,0)
	End If
	Main.currlabel = nod
	Main.currnode = nod
End Sub
Private Sub lbl_MouseEntered (EventData As MouseEvent)
	'Dim view As B4XView = Sender
	'Dim td As tagdata = view.Tag
	'If td.id.Contains("Button") Then CSSUtils.SetBackgroundColor(view, fx.Colors.LightGray)
End Sub
Private Sub lbl_MouseExited (EventData As MouseEvent)
	Main.panepressed = False
	Dim view As B4XView = Sender
	Dim td As tagdata = view.Tag
	If td.id.Contains("Pane") Then Return
	view.As(Label).MouseCursor = fx.Cursors.MOVE
	Main.set_border(view)
	'If td.id.Contains("Button") Then CSSUtils.SetBackgroundColor(view, fx.Colors.From32Bit(td.backcolor))
End Sub
Private Sub lbl_MousePressed (EventData As MouseEvent)
	' code from xulihang
	Dim event As JavaObject = EventData
	pressedX = event.RunMethod("getSceneX",Null)
	pressedY = event.RunMethod("getSceneY",Null)
	'
	Main.panepressed = False
	Dim view As B4XView = Sender
	Dim td As tagdata = view.Tag
	If td.id.Contains("Pane") Then Return
	td.PressedX = EventData.X
	td.PressedY = EventData.Y
	view.Tag = td
	Main.xpress = EventData.X
	Main.ypress = EventData.Y
	If td.PressedX <= Main.edgewidth Or td.PressedX >= view.Width - Main.edgewidth  Then Main.resizing = True
	If td.PressedY <= Main.edgewidth Or td.PressedY >= view.Height - Main.edgewidth  Then Main.resizing = True
	Main.lxpos = td.PressedX + view.Left
	Main.lypos = td.PressedY + view.Top
End Sub
Private Sub lbl_MouseReleased (EventData As MouseEvent)
	Dim view As B4XView = Sender
	Main.panepressed = False
	Main.resizing = False
	Main.snap_to_grid(view)
End Sub
Private Sub lbl_MouseMoved (EventData As MouseEvent)
	Main.panepressed = False
	Dim view As B4XView = Sender
	Dim td As tagdata = view.Tag
	If td.id.Contains("Pane") Then Return
	If td.parent <> Null And td.parent <> "null" Then Return
	Dim rightsizing As Int = view.Width - Main.edgewidth
	Dim downsizing As Int = view.Height - Main.edgewidth
	Dim leftsizing As Int = Main.edgewidth
	Dim topsizing As Int = Main.edgewidth
	If EventData.X > rightsizing Or EventData.Y > downsizing Or EventData.X < leftsizing Or EventData.Y < topsizing Then
		view.As(Label).MouseCursor = fx.Cursors.OPEN_HAND
		CSSUtils.SetBorder(view,10,fx.Colors.Blue,0)
	Else
		view.As(Label).MouseCursor = fx.Cursors.MOVE
		Main.set_border(view)
	End If
End Sub
